<%@page import="CheckoutData"%>
<%@page import="java.sql.*"%>
<%@page import="java.text.*"%>
<%@page import="java.util.*"%>


<jsp:useBean id="checkoutParams" class="CheckoutData">
	<jsp:setProperty name="checkoutParams"
	 property="cid"
	 param="Cid"/>
	<jsp:setProperty name="checkoutParams"
	 property="username"
	 param="Username"/>
	<jsp:setProperty name="checkoutParams"
	 property="cname"
	 param="Cname"/>
	<jsp:setProperty name="checkoutParams"
	 property="address"
	 param="Address"/>
	<jsp:setProperty name="checkoutParams"
	 property="basket"
	 param="Basket"/>
	<jsp:setProperty name="checkoutParams"
	 property="card1"
	 param="Card1"/>
	<jsp:setProperty name="checkoutParams"
	 property="card2"
	 param="Card2"/>
	<jsp:setProperty name="checkoutParams"
	 property="card3"
	 param="Card3"/>
	<jsp:setProperty name="checkoutParams"
	 property="card4"
	 param="Card4"/>
	<jsp:setProperty name="checkoutParams"
	 property="retry"
	 param="Retry"/>
	<jsp:setProperty name="checkoutParams"
	 property="card_month"
	 param="Card_month"/>
	<jsp:setProperty name="checkoutParams"
	 property="card_year"
	 param="Card_year"/>
</jsp:useBean>


<%
	// Part 1: Retrieve Form Data from previous Form
	// and process basket data

	String cid = checkoutParams.getCid(), 
		username = checkoutParams.getUsername(),
		basket = checkoutParams.getBasket(),
		cname = checkoutParams.getCname(), address = checkoutParams.getAddress(),
		card1 = checkoutParams.getCard1(), card2 = checkoutParams.getCard2(),
		card3 = checkoutParams.getCard3(), card4 = checkoutParams.getCard4(),
		card = card1+"-"+card2+"-"+card3+"-"+card4,
		card_month = checkoutParams.getCard_month(),
		card_year = checkoutParams.getCard_year(),
		basketCookie = checkoutParams.getBasket();

	// Convert the basket cookie data from a string to two arrays
	ArrayList items = new ArrayList(0);
	ArrayList qtys = new ArrayList(0);
	String tempWord="";
	char tempChar;
	boolean error = false;

	// We reference elements in the basket cookie as:
	//   "ISBN1,Qty1:ISBN2,Qty2:ISBN3,Qty3: ... etc for however
	// many unique elements are in the cookie
	for(int i=0; i<basketCookie.length(); i++) {
		tempChar = basketCookie.charAt(i);
		if((tempChar==',')||(tempChar==':')) {
			if(tempChar==',')
				items.add(tempWord);
			else
				qtys.add(tempWord);
			tempWord="";
		}
		else
			tempWord += tempChar;
	}
%>


<%
	// Part 2:  We then submit the order to the database

	if(checkoutParams.retry()) {

		// Step 1 - First create single entry in table Orders

		long ordernum = -1;

		Class.forName("COM.ibm.db2.jdbc.app.DB2Driver");
		Connection con = null;

		try {
			con = DriverManager.getConnection("jdbc:db2:bookshop","user","pass");
			con.setAutoCommit(false);

			// Create the insert statement
			Statement stmt= con.createStatement();
			String orderSQL= "INSERT INTO ORDERS (cid,cardnum,cardmonth,cardyear) VALUES ("
				+cid+",'"+card1+card2+card3+card4+"',"+card_month+","+card_year+")";

			// Insert the data in Orders
			stmt.executeUpdate(orderSQL);


			// Step 2 - Retrieve new generated order number

			//
			//     Note:  This step could also be accomplished
			//     using the JDBC SQL function getGeneratedKeys(),
			//     although currently this function is new to
			//     to the Java package and not 100% reliable
			//
			String retrieveSQL = "SELECT ordernum FROM ORDERS WHERE CID = "+cid+" ORDER BY ordernum DESC";
			ResultSet rs = stmt.executeQuery(retrieveSQL);
			rs.next();
			ordernum = rs.getLong("ordernum");
			String orderString = Long.toString(ordernum);
			while(orderString.length()<8)
				orderString = "0"+orderString;


			// Step 3 - Finally, create multiple entries in orderlist
			// take for each unique book in the shopping basket

			String itemSQL = "INSERT INTO OrderList (ordernum,isbn,qty) VALUES ("+ordernum+",?,?)";
			PreparedStatement pstmt = con.prepareStatement(itemSQL);
			try {
				for(int i=0; i<items.size(); i++) {
					pstmt.clearParameters();
					pstmt.setString(1,(String)items.get(i));
					pstmt.setLong(2,Long.parseLong((String)qtys.get(i)));

					// Insert data into OrderList
					pstmt.executeUpdate();
				}
				con.commit();
			} catch (SQLException e) {

				// On any errors, abort the entire
				// transaction and perform a rollback
				error = true;
				con.rollback();
				out.println("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=dberror.html\">");
			}


			// Part 3:  If the order was submitted successfully,
			// we inform the user

			if(!error) {
				// First, delete order cookie
                        Cookie basketCookieRemove = new Cookie("basket","");
				basketCookieRemove.setMaxAge(-1);
				response.addCookie(basketCookieRemove);

				// Display the HTML page header
				out.println("<HTML>");
				out.println("<TITLE>Order Sent</TITLE>");
				out.println("<BODY>");
				out.println("<script language=\"javascript\" src=\"menu.js\"></script>");
				out.println("<TABLE ALIGN=\"CENTER\" WIDTH=\"70%\">");
				out.println("<TR ALIGN=\"CENTER\"><TD><H2><I>Order Sent!</I></H2></TD></TR>");

				//  Format order number output to be 8 digits
				out.println("<TR><TD><P>Your Order Number is #"+orderString+".  Please write it down to be safe.");
				out.println("If you need to contact us about an order, please include this number with your e-mail.</P>");
				out.println("</TD></TR></TABLE><BR/><BR/><BR/><BR/><BR/><BR/>");

				// Display the HTML page tail
				out.println("</BODY>");
				out.println("<script language=\"javascript\" src=\"footer.js\"></script>");
				out.println("</HTML>");

			}

			rs.close();
			pstmt.close();
			stmt.close();
			con.close();
		} catch (Exception e) {

			// On any errors, abort the entire transaction
			// and perform a rollback
			con.rollback();
			out.println("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=dberror.html\">");
		}
	}


	// Part 4: If user attempts to access this JSP outside
	// the context of a form session, we display an error
	else
		out.println("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"0; URL=expiredform.html\">");
%>